/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/GeometricBehaviour.h $
 $LastChangedRevision: 81 $
 $Date: 2014-07-02 11:07:09 -0400 (Wed, 02 Jul 2014) $
 $Author: olangthaler $
 ***********************************************************
 */

#ifndef GEOMETRICBEHAVIOUR_H_
#define GEOMETRICBEHAVIOUR_H_

#include "blkdta.h"

/**
 * Class to hold all functions related to the geometric behaviour. Can be used for the strategy pattern.
 */
class GeometricBehaviour
{

public:
	GeometricBehaviour();
	virtual ~GeometricBehaviour();

	static GeometricBehaviour* getInstance();

	virtual void getRayTrace(INTEGER np, INTEGER nr, INTEGER* list,
	REAL* weight, INTEGER* numb, REAL* snorm, REAL * _sorx = 0,
	REAL * _sory = 0, REAL * _cf = 0, REAL * _sf = 0) = 0;

	virtual INTEGER getArea() = 0;

	INTEGER getArrayIndex(INTEGER row, INTEGER column);

	void getPixelPosition(INTEGER arrayIndex, INTEGER* row, INTEGER* column);

}
;
#endif /* GEOMETRICBEHAVIOUR_H_ */
