/* 
***********************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/art.h $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
***********************************************************
*/

#ifndef XALG1_H
#define XALG1_H      

#include "alg.h"

class artin_class
{ 
  public:
  INTEGER kount;
  INTEGER p;
  INTEGER npin;    // projection curently in delta buffer
	
  REAL* totalRays;	//Ran, bug 266

  BOOLEAN art2f;
  BOOLEAN art3f;
  BOOLEAN art4f;
  BOOLEAN tolerf;
  BOOLEAN rconsf;
  BOOLEAN nomlf;
  BOOLEAN bartf;
  BOOLEAN bayef;
  BOOLEAN noisef;
  BOOLEAN crf;

  REAL toler;
  REAL relax;
  REAL thrlo;
  REAL thrup;
  REAL halfwy;
  REAL thtol;
  REAL snr;
  REAL snr2;
  REAL cr;
  REAL ct;
};

class art_class: public alg_class
{
private:
  artin_class ArtIn;
  //FileUser3_class Xalg1User3; //Ran, bug 266

  REAL clip(REAL temp, REAL thrlo, REAL thrup, REAL relax);

  REAL rset(
    REAL* recon, 
    INTEGER iter,
    INTEGER np,
    INTEGER nr,
    INTEGER i,
    REAL raysum, 
    INTEGER* list,
    REAL* weight,
    BOOLEAN *flag
  );

  REAL tset(REAL* recon, INTEGER iter, INTEGER np, INTEGER nr,INTEGER i, REAL raysum, INTEGER* list, REAL* weight, BOOLEAN* flag);

  REAL crset(REAL* recon, INTEGER iter, INTEGER np, INTEGER nr, INTEGER i, REAL raysum, INTEGER* list, REAL* weight, BOOLEAN* flag);

  void readin(REAL* recon, INTEGER* list, REAL* weight, BOOLEAN* flag);

  void bkproj( REAL* recon, REAL diff, REAL abdiff, REAL* ibase, INTEGER np, INTEGER nr, INTEGER* list, REAL* weight, INTEGER numb, REAL snorm);

  void artbck(REAL* pict, REAL amt, INTEGER* list,REAL* weight,INTEGER numb,REAL thrlo,REAL thrup,REAL relax,BOOLEAN bartf,REAL halfwy,REAL thtol, BOOLEAN art2f);

public:
  INTEGER Init();
  BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight, INTEGER iter);
  INTEGER Reset();
};

#endif      
