/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/art_bkproj.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 CALCULATE BACKPROJECTIONS
 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "uiod.h"
#include "geom.h"

#ifdef FFCOMPARE
#include "geom.h"
#endif

#include "art.h"

void art_class::bkproj(REAL* recon, REAL diff,REAL abdiff,REAL* ibase, INTEGER np, INTEGER nr, INTEGER* list, REAL* weight, INTEGER numb, REAL snorm)
{
	REAL change;
	REAL dual; //wei, bug 266
	REAL a;
	REAL b;
	REAL factor;


	if (ArtIn.bayef)
	{
		// BAYESIAN
		//index = indexd(np, nr); //Ran, bug 266
		dual = ArtIn.totalRays[np * GeoPar.nrays + nr];
		change = diff - dual;  //wei, bug 266
		snorm = (REAL) 1.0 + snorm * ArtIn.snr2;
	}
	else if (ArtIn.art4f)
	{
		// ART4
		// index = indexd(np, nr); //Ran, bug 266
		dual = ArtIn.totalRays[np * GeoPar.nrays + nr]; //wei, bug 266
		a = diff + ArtIn.toler;
		b = diff - ArtIn.toler;

		change = MAX0(MIN0(a, dual), b);
		ArtIn.totalRays[np * GeoPar.nrays + nr] -= change * ArtIn.relax; //wei, bug 266
	}

	// ART3
	else
	{
		if (abdiff <= ArtIn.toler)
		{
			return;
		}

		if (abdiff >= ArtIn.toler + ArtIn.toler)
		{
			change = diff;
		}
		else
		{
			// REFLECTION
			if (diff < 0)
				change = (REAL) 2.0 * (diff + ArtIn.toler); //  -2*toler < diff <-toler
			else
				change = (REAL) 2.0 * (diff - ArtIn.toler); //  toler < diff < 2* toler      by wei, 8/2005
		}
	}
	// ADJUST RECONSTRUCTED PICTURE

	factor = ArtIn.relax * change / snorm;

#ifdef FFCOMPARE

#endif  

	if (ArtIn.bayef)
	{
		ArtIn.totalRays[np * GeoPar.nrays + nr] += factor;  //wei, bug 266
		factor *= ArtIn.snr2;
	}

	////////// dump recon ////////////
#ifdef FFCOMPARE

#endif
	//////////////////////////////////


	artbck(recon, factor, list, weight, numb, ArtIn.thrlo, ArtIn.thrup,
			ArtIn.cr, ArtIn.bartf, ArtIn.halfwy, ArtIn.thtol, ArtIn.art2f);

	return;
}

