/* 
***********************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/bdhk.h $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
***********************************************************
*/


#ifndef BDHK_H
#define BDHK_H

#include "alg.h"

  struct NPNR
  {
    INTEGER NP;
    INTEGER NR;
  };

 
class bdhk_class: public alg_class
{
private:
//misl.h
  
  REAL AVER(REAL A, REAL B);

  REAL neigSum_General(REAL* recon, REAL* d, int kernel_size);

  REAL AVER3(REAL A, REAL B, REAL C);

  REAL diffAbs(REAL A, REAL B);

  REAL neigSum(REAL* recon, REAL* v);

  void orderRays(struct NPNR* arrayRays, INTEGER kount);

  REAL calcTV(REAL* recon);
  
  BOOLEAN calculateGradientTV(REAL* grad, REAL* recon);

  REAL calcHalfNormSquare(REAL* recon);

  REAL calcNorm(REAL* aVector);
  //calcNorm calculates the square-root of the norm square of a vector ||V||
  
  REAL squareNorm(REAL* aVector);
  //squareNorm calculates the norm square of a vector ||V||^2

  REAL calculateResidual(REAL* recon, INTEGER* list, REAL* weight, struct NPNR* arrayRays, INTEGER kount);
  //calculates the residual of recon from its pseudo projections

  void MyART(REAL* recon, INTEGER* list, REAL* weight, struct NPNR* arrayRays, INTEGER kount);



//algp.h
   REAL BETA;
   struct NPNR* arrayRays;
   INTEGER kount;
   INTEGER KOUNT; //user paramater to control "STEPS kount" like
   BOOLEAN flag_kount;
   INTEGER kernel_size;

public:
  INTEGER Init();
  BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight, INTEGER iter);
  INTEGER Reset();
};

#endif      
