/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/errorc.c $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 Previously part of SuperSNARK
 */

#include "stdlib.h"
#include "string.h"
#include "experimenter.h"
#include "errorc.h"

/* ------------------------ error_message.c ------------------------ */

/* function to handle error messages */

void errorc(char* str1, char* str2)
{
	char message[MAXLINESIZE];

	strcpy(message, str1);
	strcat(message, str2);
	strcat(message, "\n");
	fprintf(stderr, message);
	exit(1);
}

//bug 269 - jklukowska
//returns true if the line should be skipped (because it is blank
//or starts with a * - comment line)
int isSkip(char * line)
{
	int i = 0;
	while (line[i] == ' ' || line[i] == '\t' || line[i] == '\n')
		i++;
	//if the next character is null return true
	if (line[i] == '\0')
		return 1;
	//or if the first non white space character is a star
	else if (line[i] == '*')
		return 1;
	else
		return 0;
}

int isBlank(char * line)
{
	int i = 0;
	while (line[i] == ' ' || line[i] == '\t' || line[i] == '\n')
		i++;
	//if the next character is null return true
	if (line[i] == '\0')
		return 1;
	else
		return 0;
}

int isComment(char * line)
{
	int i = 0;
	while (line[i] == ' ' || line[i] == '\t' || line[i] == '\n')
		i++;
	//if the first non white space character is a star
	if (line[i] == '*')
		return 1;
	else
		return 0;
}

int isValidObject(char * line)
{
	if (strncasecmp(line, "elip", 4) == 0 || strncasecmp(line, "rect", 4) == 0
			|| strncasecmp(line, "tria", 4) == 0
			|| strncasecmp(line, "segm", 4) == 0
			|| strncasecmp(line, "sect", 4) == 0)
		return 1;
	else
		return 0;
}

