/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_error.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 ------------------------------------------------------------------

 PURPOSE: PRINT ERROR MESSAGES

 ------------------------------------------------------------------
*/

#include <cstdio>

#include "blkdta.h"
#include "fourie.h"
#include "uiod.h"
#include "foru.h"

void foru_class::error(INTEGER ktype)
{      
  Fourie.iflg = 1;
  fprintf(output, "\n*****error*****error*****");

  switch(ktype) {
  case 1:
    fprintf(output, "\nfor parallel geometry, total span should be less than pi and ge pi/2 for uniform proj and ge 3/4pi for variable proj");
    break;

  case 2:
    fprintf(output, "\nfor divergent geometry, total span should be greater than 3/2pi and less than two pi");
    break;

  case 3:
    fprintf(output, "\nangles must be in increasing order");
    break;

  case 4:
    fprintf(output, "\nangles must not be separated by more than pi/2 for uniform proj and pi/4 for variable proj");
    break;

  case 5:
    fprintf(output, "\ninsufficient parameters");
    break;

  case 6:
    fprintf(output, "\nillegal input data");
    break;

  case 8:
    fprintf(output, "\ninterp should be ge 1 and le 4");
    break;
  }

  fprintf(output, "\n*****error*****error*****");

  return;
}

