/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_ftfill.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 PURPOSE: REARRANGE THE NUMBERS IN ARRAY G (OF SIZE MAXG1*MAXG1)
 AND PUT INTO THE ARRAY RECON
 */

#include <cstdio>

#include "blkdta.h"
#include "geom.h"

#include "foru.h"

void foru_class::ftfill(REAL* recon, REAL* g, INTEGER maxg1)
{
	INTEGER no2;
	INTEGER l1;
	INTEGER l2;
	INTEGER len;
	INTEGER ibaser;
	INTEGER kk;
	INTEGER iy;
	INTEGER indr;
	INTEGER itmp;
	INTEGER ibaseg;
	INTEGER ll;
	INTEGER ix;
	INTEGER indg;

	no2 = GeoPar.nelem / 2;
	l1 = -no2;
	l2 = no2;
	len = l2 - l1 + 1;
	ibaser = GeoPar.area - GeoPar.nelem;
	for (kk = 0; kk < len; kk++)
	{
		iy = l1 + kk;
		indr = ibaser;
		itmp = iy;
		if (iy < 0)
			itmp = maxg1 + iy;
		ibaseg = itmp * maxg1;

		for (ll = 0; ll < len; ll++)
		{
			ix = l1 + ll;
			itmp = ix;
			if (ix < 0)
				itmp = maxg1 + ix;
			indg = ibaseg + itmp;
			recon[indr] = g[indg];
			indr++;
		}
		ibaser -= GeoPar.nelem;
	}
	return;
}
