/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/main.cpp $
 $LastChangedRevision: 118 $
 $Date: 2014-07-09 14:22:29 -0400 (Wed, 09 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#include <cstdio>

//jk 12/08/07  combining snark with experimenter into a single program
#include <unistd.h>         //provides routine for parsing the command line

#include "snark.h"
extern "C"
{
#include "experimenter.h"
}

int main(int argc, char *argv[])
{
	int choice = 1;       //runs "plain snark" by default
	int c;
	extern int optind, optopt;

	while ((c = getopt(argc, argv, "eh")) != -1)
	{
		switch (c)
		{
		case 'e':
			choice = 2;
			break;
		case 'h':
			fprintf(stderr, "\nsnark14 [-e] [-h] [input_file] [>>output_file]\n");
			fprintf(stderr, "  \tRuns snark14 image reconstruction program.\n");
			fprintf(stderr, "  \nOPTIONS:\n");
			fprintf(stderr, "  -e \truns the experimenter\n");
			fprintf(stderr, "  -h \tdisplays this help message\n");
			fprintf(stderr, "  input_file \tcontains input for either snark14 or experimenter \n");
			fprintf(stderr, "  >>output_file \toutput is redirected to this file\n\n");
			return 0;
		case '?':
			fprintf(stderr,
					"Unrecognized option: -%c\nRun \"snark14 -h\"  for more information.\n\n",
					optopt);
			return -1;

		}
	}

	if (argc - optind + 1 > 2)
	{
		fprintf(stderr, "ERROR: too many arguments on the command line.\n"
				"Run \"snark14 -h\"  for more information.\n\n");
		return 0;
	}

	if (1 == choice)
	{
		//call snark14 and pass the parameters
		snark(argc - optind + 1, argv);
	}
	else if (2 == choice)
	{
		//call snark14Experimenter and pass the parameters
		experimenter(argc - optind + 1, argv);
	}
	else
	{
		fprintf(stderr, "Error: Invalid choice entered. \n\n");
	}

	return 0;

} //end of main
