/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/second.cpp $
 $LastChangedRevision: 96 $
 $Date: 2014-07-02 20:06:42 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS SUBROUTINE IS PECULIAR TO THE BURROUGH'S B1700 SERIES.
 THE SUBROUTINE IS STANDARD ON THE CDC 6000 AND CYBER SERIES.
 ON OTHER MACHINES IT MUST BE MODIFIED TO CONFORM TO THE
 OPERATING SYSTEMS CONVENTIONS OF RETURNING THE ELAPSED CPU TIME
 SINCE THE BEGINNING OF THE JOB.

 CALLS FORTRAN INTRINSIC FUNCTION 'TIME'; INTEGER FUNCTION
 WITH INTEGER ARGUMENTS ; TIME IN TENTHS OF SECONDS

 FOR VM-CMS ON A VMX THERE IS NO TIME ROUTINE
 */

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>

#include "blkdta.h"
#include "second.h"

void second(REAL* ctime)
{
	struct rusage usage;

	getrusage(RUSAGE_SELF, &usage);
	*ctime = usage.ru_utime.tv_sec + usage.ru_utime.tv_usec * 0.000001;
}

