/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/unkps.cpp $
 $LastChangedRevision: 122 $
 $Date: 2014-07-09 18:18:59 -0400 (Wed, 09 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"

#include "unkps.h"


void unkps( INTEGER imax, INTEGER istep, REAL* xs, REAL* x, INTEGER m, INTEGER nipf, INTEGER krad, INTEGER mc, INTEGER ir, INTEGER n, INTEGER* ix, INTEGER* ipu, INTEGER nfixp, INTEGER k4m4, BOOLEAN virt)
{
	BOOLEAN dovirt;

	REAL md4;
	REAL kradm;
	INTEGER k4mx;
	INTEGER k4mxm;
	INTEGER k4minc;
	INTEGER jlim;
	INTEGER i;
	INTEGER j;
	INTEGER js;
	INTEGER inc;
	INTEGER jl;
	INTEGER nn;
	INTEGER kp;
	INTEGER kp1;
	INTEGER ju;
	INTEGER jus;
	INTEGER kx;
	INTEGER ia;
	INTEGER l;
	INTEGER ind;
	INTEGER inx;
	INTEGER ib;
	INTEGER ind2;
	INTEGER kumx;
	INTEGER ku;
	INTEGER kvmn;
	INTEGER kv;
	INTEGER kp2;
	INTEGER k4mxm1;
	INTEGER kp1x;
	INTEGER kp2x;
	INTEGER kp1xx;
	INTEGER kp2xx;
	INTEGER kpl;
	INTEGER kount;

	dovirt = virt && (istep > 1);
	md4 = m / krad;
	if ((md4 == 0) && (nipf < 2))
		return;
	kradm = krad - 1;
	k4mx = k4m4 * ir;
	k4mxm = k4mx - k4m4;
	k4minc = k4m4;
	ix[0] = 0;
	jlim = 1;

	for (i = 0; i < md4; i++)
	{
		for (j = 1; j <= jlim; j++)
		{
			js = j - 1;
			inc = 0;
			ix[j - 1] *= krad;
			for (jl = 0; jl < kradm; jl++)
			{
				js += jlim;
				inc += k4mx;
				ix[js] = ix[j - 1] + inc;
			}
		}
		jlim *= krad;
	}

	nn = n / (1 << m);

	if (!(nipf < 2))
	{
		k4minc = k4mxm;

		for (kp = 0; kp < k4m4; kp++)
		{
			kp1 = ix[kp] + kp;
			ju = nfixp;

			do
			{
				jus = ju;
				kx = kp1 + ipu[ju];
				ia = kx * istep;


				for (l = 0; l < imax; l++)
				{
					ind = l + ia;
					CA(xs, 0, l)= CA(x, 0, ind);
					CA(xs, 1, l)= CA(x, 1, ind);
				}

				ju++;

				do
				{
					inx = kp1 + ipu[ju];
					ia = kx * istep;

					ib = inx * istep;

					for (l = 0; l < imax; l++)
					{
						ind = l + ia;
						ind2 = l + ib;
						CA(x, 0, ind)= CA(x, 0, ind2);
						CA(x, 1, ind)= CA(x, 1, ind2);
					}

					ju++;

					kx = inx;

				} while (ipu[ju] != 0);

				ia = kx * istep;

				for (l = 0; l < imax; l++)
				{
					ind = l + ia;
					CA(x, 0, ind)= CA(xs, 0, l);
					CA(x, 1, ind)= CA(xs, 1, l);
				}

				ju++;

			} while (ipu[ju] < n);
		}
	}

	if (md4 < 1)
		return;

	kumx = k4m4 - 1;

	for (ku = 0; ku < kumx; ku++)
	{
		kvmn = ku + 1;
		for (kv = kvmn; kv < k4m4; kv++)
		{

			kp1 = ix[ku] + kv;
			kp2 = ix[kv] + ku;

			k4mxm1 = k4mxm + 1;

			for (inc = 0; inc < k4mxm1; inc += k4minc)
			{

				kp1x = kp1 + inc;
				kp2x = kp2 + inc;

				ia = kp1x * istep;

				ib = kp2x * istep;


				for (l = 0; l < imax; l++)
				{
					kp1xx = l + ia;
					kp2xx = l + ib;

					CA(xs, 0, l)= CA(x, 0, kp1xx);
					CA(xs, 1, l)= CA(x, 1, kp1xx);

					CA(x, 0, kp1xx)= CA(x, 0, kp2xx);
					CA(x, 1, kp1xx)= CA(x, 1, kp2xx);

					CA(x, 0, kp2xx)= CA(xs, 0, l);
					CA(x, 1, kp2xx)= CA(xs, 1, l);
				}
			}

			// code below is not tested !!! mk
			// after some correction it seems to work - Laszlo

			if (!(nipf < 2))
			{

				if (!(nfixp == 0))
				{

					for (ju = 0; ju < nfixp; ju++)
					{

						ind = kp1 + ipu[ju];
						ia = (ind) * istep;


						ind = kp2 + ipu[ju];
						ib = (ind) * istep;


						for (l = 0; l < imax; l++)
						{
							kp1x = l + ia;
							kp2x = l + ib;

							CA(xs, 0, l)= CA(x, 0, kp1x);
							CA(xs, 1, l)= CA(x, 1, kp1x);


							CA(x, 0, kp1x)= CA(x, 0, kp2x);
							CA(x, 1, kp1x)= CA(x, 1, kp2x);

							CA(x, 0, kp2x)= CA(xs, 0, l);
							CA(x, 1, kp2x)= CA(xs, 1, l);
						}
					}
				}

				ju = nfixp;
				do
				{
					kount = 1;
					jus = ju;
					kpl = 0;
					kx = kp1 + ipu[ju];

					for(;;)
					{
						ia = (kx) * istep;

						for(l = 0; l < imax; l++)
						{
							ind = l + ia;
							CA(xs, 0, l) = CA(x, 0, ind);
							CA(xs, 1, l) = CA(x, 1, ind);
						}

						ju++;

						do
						{
							do
							{
								kpl = 1 - kpl;

								if(kpl == 1) inx = kp2 + ipu[ju];
								if(kpl == 0) inx = kp1 + ipu[ju];

								ia = (kx) * istep;


								ib = (inx) * istep;


								for(l = 0; l < imax; l++)
								{

									ind = l + ia;
									ind2 = l + ib;

									CA(x, 0, ind) = CA(x, 0, ind2);
									CA(x, 1, ind) = CA(x, 1, ind2);

								}

								ju++;
								kx = inx;

							}while(ipu[ju] != 0);

							if(kount == 2) goto L12;

							kount = 2;
							ju = jus;

						}while(kpl == 0);

						ia = (kx) * istep;


						for(l = 0; l < imax; l++)
						{
							ind = l + ia;

							CA(x, 0, ind) = CA(xs, 0, l);
							CA(x, 1, ind) = CA(xs, 1, l);
						}

						kx = kp2 + ipu[ju];
					}

					L12:

					ia = (kx) * istep;

					for(l = 0; l < imax; l++)
					{
						ind = l + ia;

						CA(x, 0, ind) = CA(xs, 0, l);
						CA(x, 1, ind) = CA(xs, 1, l);
					}

					ju++;

				}while(ipu[ju] < n);
			}
		}
	}
	return;
}
