#include "super.h"
#include "variables.h"
#include "misc.h"
#include <stdio.h>

#include <qbuttongroup.h>
#include <qframe.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>

superwindow::superwindow(QWidget* parent, const char* name, bool modal, WFlags fl) : QDialog(parent, name, modal, fl)
{
	if (!name) setName("superwindow");
	resize(600, 340);
	setSizePolicy( QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0, sizePolicy().hasHeightForWidth()));
	setMinimumSize(QSize(600, 280));
	setMaximumSize(QSize(600, 280));
	setCaption(tr("Superiorize Window"));

	superlabel = new QLabel(this, "superlabel");
	superlabel->setGeometry(QRect(10, 10, 150, 30));
	superlabel->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0, superlabel->sizePolicy().hasHeightForWidth()));
	superlabel->setMinimumSize(QSize(150, 30));
	superlabel->setMaximumSize(QSize(150, 30));
	superlabel->setText(tr("SUPERIORIZE"));

	superbuttongroup = new QButtonGroup(this, "superbuttongroup");
	superbuttongroup->setGeometry(QRect(15, 45, 575, 155));
	superbuttongroup->setTitle(tr("options"));
	superbuttongroup->setAlignment(int(QButtonGroup::AlignHCenter));

	N = new QLineEdit(superbuttongroup, "N");
	N->setGeometry(QRect(10, 45, 80, 24));
	N->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,N->sizePolicy().hasHeightForWidth()));
	N->setEnabled(true);

	Nlabel = new QLabel(superbuttongroup, "Nlabel");
	Nlabel->setGeometry(QRect(45, 20, 40, 20));
	Nlabel->setText(tr("N"));
	Nlabel->setEnabled(true);

	a = new QLineEdit(superbuttongroup, "a");
	a->setGeometry(QRect(100, 45, 80, 24));
	a->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,a->sizePolicy().hasHeightForWidth()));
	a->setEnabled(true);

	alabel = new QLabel(superbuttongroup, "alabel");
	alabel->setGeometry(QRect(135, 20, 40, 20));
	alabel->setText(tr("a"));
	alabel->setEnabled(true);

	b = new QLineEdit(superbuttongroup, "b");
	b->setGeometry(QRect(190, 45, 80, 24));
	b->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,b->sizePolicy().hasHeightForWidth()));
	b->setEnabled(true);

	blabel = new QLabel(superbuttongroup, "blabel");
	blabel->setGeometry(QRect(225, 20, 40, 20));
	blabel->setText(tr("b"));
	blabel->setEnabled(true);

	sec_cri = new QComboBox(superbuttongroup, "sec_cri");
	sec_cri->setGeometry(QRect(15, 100, 130, 30));
	sec_cri->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,sec_cri->sizePolicy().hasHeightForWidth()));
	sec_cri->insertItem("TVAR", -1);
	sec_cri->insertItem("SMOO", -1);
	sec_cri->insertItem("SCR3", -1);
	sec_cri->insertItem("SCR4", -1);
	sec_cri->insertItem("SCR5", -1);
	sec_cri->setEnabled(true);
	//QObject::connect(sec_cri,SIGNAL(activated(int)),this,SLOT(setEpsilon()));

	sec_crilabel = new QLabel(superbuttongroup, "sec_crilabel");
	sec_crilabel->setGeometry(QRect(10, 80, 145, 20));
	sec_crilabel->setText(tr("secondary criterion"));
	sec_crilabel->setEnabled(true);

	altl = new QComboBox(superbuttongroup, "altl");
	altl->setGeometry(QRect(195, 100, 130, 30));
	altl->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,altl->sizePolicy().hasHeightForWidth()));
	altl->insertItem("NONE", -1);
	altl->insertItem("ATL1", -1);
	altl->insertItem("ATL2", -1);
	altl->setEnabled(true);
	//QObject::connect(sec_cri,SIGNAL(activated(int)),this,SLOT(setEpsilon()));

	altllabel = new QLabel(superbuttongroup, "altllabel");
	altllabel->setGeometry(QRect(215, 80, 100, 20));
	altllabel->setText(tr("alternative l"));
	altllabel->setEnabled(true);

	rprtcb = new QCheckBox( this, "rprtcb" );
	rprtcb->setGeometry(QRect(380, 145, 80, 30));
	rprtcb->setText( "RPRT" );
	rprtcb->setChecked(false);
	rprtcb->setEnabled(true);
	QObject::connect(rprtcb,SIGNAL(clicked()),this,SLOT(setSkips()));

	skips = new QLineEdit(superbuttongroup, "skips");
	skips->setGeometry(QRect(450, 100, 80, 30));
	skips->setSizePolicy(QSizePolicy((QSizePolicy::SizeType) 0, (QSizePolicy::SizeType) 0,skips->sizePolicy().hasHeightForWidth()));
	skips->setEnabled(false);

	skipslabel = new QLabel(superbuttongroup, "skipslabel");
	skipslabel->setGeometry(QRect(465, 80, 60, 20));
	skipslabel->setText(tr("skips"));
	skipslabel->setEnabled(false);

	okbutton = new QPushButton(this, "okbutton");
	okbutton->setGeometry(QRect(50, 230, 100, 40));
	okbutton->setText(tr("OK"));
	QObject::connect(okbutton, SIGNAL(clicked()), this, SLOT(checkValues()));

	cancelbutton = new QPushButton(this, "cancelbutton");
	cancelbutton->setGeometry(QRect(280, 230, 100, 40));
	cancelbutton->setText(tr("Cancel"));
	QObject::connect(cancelbutton, SIGNAL(clicked()), this, SLOT(reject()));
}

/**  
 *  Destroys the object and frees any allocated resources
 */
superwindow::~superwindow()
{
	// no need to delete child widgets, Qt does it all for us
}

void superwindow::setSkips()
{
	if (rprtcb->isChecked())
	{
		skips->setEnabled(TRUE);
		skipslabel->setEnabled(TRUE);
	}
	else
	{
		skips->setEnabled(FALSE);
		skipslabel->setEnabled(FALSE);
	}
}

QString superwindow::getOutput()
{
	QString output;

	output.sprintf("SUPERIORIZE ");

	output += N->text();
	output.append(" ");
	output += a->text();
	output.append(" ");
	output += b->text();
	output.append(" ");

	switch (sec_cri->currentItem())
	{
	case 0:
		output.append("TVAR");
		break;
	case 1:
		output.append("SMOO");
		break;
	case 2:
		output.append("SCR3");
		break;
	case 3:
		output.append("SCR4");
		break;
	case 4:
		output.append("SCR5");
		break;
	}

	switch (altl->currentItem())
	{
	case 0:
		// "none" is selected
		break;
	case 1:
		output.append(" ATL1");
		break;
	case 2:
		output.append(" ATL2");
		break;
	}

	if (rprtcb->isChecked())
	{
		output.append(" RPRT");

		float s = strtof((const char *) skips->text());
		if (s>1)
		{
			output.append(" ");
			output += skips->text();
		}
	}

	return output;
}

void superwindow::checkValues()
{
	int f = 0;
	int iN = 0;
	float fa = 0;
	float fb = 0;
	int is = 0;

	iN = strtoi((const char *) N->text());
	if (errnum) f = 1;
	if (iN < 1) f = 2;

	fa = strtof((const char *) a->text());
	if (errnum) f = 3;
	if ( fa <= 0 || fa>=1 ) f = 4;

	fb = strtof((const char *) b->text());
	if (errnum) f = 5;
	if ( fb <= 0 || fb>1 ) f = 6;

	switch (f)
	{
	case 0:
		accept();
		break;
	case 1:
		QMessageBox::information(this, "SnarkInput", "Error!\n"	"Invalid N format.");
		N->setFocus();
		break;
	case 2:
		QMessageBox::information(this, "SnarkInput", "Error!\n" "N must be >0.");
		N->setFocus();
		break;
	case 3:
		QMessageBox::information(this, "SnarkInput", "Error!\n"	"Invalid a format.");
		a->setFocus();
		break;
	case 4:
		QMessageBox::information(this, "SnarkInput", "Error!\n" "a must be >0 and <1.");
		a->setFocus();
		break;
	case 5:
		QMessageBox::information(this, "SnarkInput", "Error!\n"	"Invalid b format.");
		b->setFocus();
		break;
	case 6:
		QMessageBox::information(this, "SnarkInput", "Error!\n" "b must be >0 and <=1.");
		b->setFocus();
		break;
	}
}
